/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domen;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author student
 */
@Entity
@Table(name = "proizvod")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Proizvod.findAll", query = "SELECT p FROM Proizvod p")
    , @NamedQuery(name = "Proizvod.findByProizvodID", query = "SELECT p FROM Proizvod p WHERE p.proizvodID = :proizvodID")
    , @NamedQuery(name = "Proizvod.findByCena", query = "SELECT p FROM Proizvod p WHERE p.cena = :cena")})
public class Proizvod implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "proizvodID")
    private Integer proizvodID;
    @Lob
    @Size(max = 65535)
    @Column(name = "naziv")
    private String naziv;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "cena")
    private Double cena;
    @OneToOne(cascade = CascadeType.ALL, mappedBy = "proizvod")
    private Prehrambeniproizvod prehrambeniproizvod;
    @OneToMany(mappedBy = "proizvodID")
    private List<Stavkaracuna> stavkaracunaList;
    @OneToOne(cascade = CascadeType.ALL, mappedBy = "proizvod")
    private Tehnickiproizvod tehnickiproizvod;

    public Proizvod() {
    }

    public Proizvod(Integer proizvodID) {
        this.proizvodID = proizvodID;
    }

    public Integer getProizvodID() {
        return proizvodID;
    }

    public void setProizvodID(Integer proizvodID) {
        this.proizvodID = proizvodID;
    }

    public String getNaziv() {
        return naziv;
    }

    public void setNaziv(String naziv) {
        this.naziv = naziv;
    }

    public Double getCena() {
        return cena;
    }

    public void setCena(Double cena) {
        this.cena = cena;
    }

    public Prehrambeniproizvod getPrehrambeniproizvod() {
        return prehrambeniproizvod;
    }

    public void setPrehrambeniproizvod(Prehrambeniproizvod prehrambeniproizvod) {
        this.prehrambeniproizvod = prehrambeniproizvod;
    }

    @XmlTransient
    public List<Stavkaracuna> getStavkaracunaList() {
        return stavkaracunaList;
    }

    public void setStavkaracunaList(List<Stavkaracuna> stavkaracunaList) {
        this.stavkaracunaList = stavkaracunaList;
    }

    public Tehnickiproizvod getTehnickiproizvod() {
        return tehnickiproizvod;
    }

    public void setTehnickiproizvod(Tehnickiproizvod tehnickiproizvod) {
        this.tehnickiproizvod = tehnickiproizvod;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (proizvodID != null ? proizvodID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Proizvod)) {
            return false;
        }
        Proizvod other = (Proizvod) object;
        if ((this.proizvodID == null && other.proizvodID != null) || (this.proizvodID != null && !this.proizvodID.equals(other.proizvodID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "domen.Proizvod[ proizvodID=" + proizvodID + " ]";
    }
    
}
