/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domen;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author student
 */
@Entity
@Table(name = "stavkaracuna")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Stavkaracuna.findAll", query = "SELECT s FROM Stavkaracuna s")
    , @NamedQuery(name = "Stavkaracuna.findByRacunID", query = "SELECT s FROM Stavkaracuna s WHERE s.stavkaracunaPK.racunID = :racunID")
    , @NamedQuery(name = "Stavkaracuna.findByRb", query = "SELECT s FROM Stavkaracuna s WHERE s.stavkaracunaPK.rb = :rb")
    , @NamedQuery(name = "Stavkaracuna.findByKolicina", query = "SELECT s FROM Stavkaracuna s WHERE s.kolicina = :kolicina")})
public class Stavkaracuna implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected StavkaracunaPK stavkaracunaPK;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "kolicina")
    private Double kolicina;
    @JoinColumn(name = "racunID", referencedColumnName = "racunID", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Racun racun;
    @JoinColumn(name = "proizvodID", referencedColumnName = "proizvodID")
    @ManyToOne
    private Proizvod proizvodID;

    public Stavkaracuna() {
    }

    public Stavkaracuna(StavkaracunaPK stavkaracunaPK) {
        this.stavkaracunaPK = stavkaracunaPK;
    }

    public Stavkaracuna(int racunID, int rb) {
        this.stavkaracunaPK = new StavkaracunaPK(racunID, rb);
    }

    public StavkaracunaPK getStavkaracunaPK() {
        return stavkaracunaPK;
    }

    public void setStavkaracunaPK(StavkaracunaPK stavkaracunaPK) {
        this.stavkaracunaPK = stavkaracunaPK;
    }

    public Double getKolicina() {
        return kolicina;
    }

    public void setKolicina(Double kolicina) {
        this.kolicina = kolicina;
    }

    public Racun getRacun() {
        return racun;
    }

    public void setRacun(Racun racun) {
        this.racun = racun;
    }

    public Proizvod getProizvodID() {
        return proizvodID;
    }

    public void setProizvodID(Proizvod proizvodID) {
        this.proizvodID = proizvodID;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (stavkaracunaPK != null ? stavkaracunaPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Stavkaracuna)) {
            return false;
        }
        Stavkaracuna other = (Stavkaracuna) object;
        if ((this.stavkaracunaPK == null && other.stavkaracunaPK != null) || (this.stavkaracunaPK != null && !this.stavkaracunaPK.equals(other.stavkaracunaPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "domen.Stavkaracuna[ stavkaracunaPK=" + stavkaracunaPK + " ]";
    }
    
}
