/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mb;

import domen.Korisnik;
import domen.Mesto;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;
import javax.annotation.PostConstruct;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import kontroler.Kontroler;

/**
 *
 * @author student
 */
@Named(value = "mbKorisnik")
@SessionScoped
public class MBKorisnik implements Serializable {

    @Inject
    Kontroler kontroler;

    /**
     * Creates a new instance of MBKorisnik
     */
    public MBKorisnik() {
        korisnik = new Korisnik();        
    }
    
    
    @PostConstruct
    public void inicijalizujPodatke(){
        
        listaKorisnika = kontroler.vratiListuKorisnika();
        listaMesta = kontroler.vratiListuMesta();
        
    }
    

    private Korisnik korisnik;

    private String ponovljenaSifra;
    
    private List<Mesto> listaMesta;
    
    private List<Korisnik> listaKorisnika;
    

    public Korisnik getKorisnik() {
        return korisnik;
    }

    public void setKorisnik(Korisnik korisnik) {
        this.korisnik = korisnik;
    }

    public String getPonovljenaSifra() {
        return ponovljenaSifra;
    }

    public void setPonovljenaSifra(String ponovljenaSifra) {
        this.ponovljenaSifra = ponovljenaSifra;
    }

    public List<Mesto> getListaMesta() {
        return listaMesta;
    }

    public void setListaMesta(List<Mesto> listaMesta) {
        this.listaMesta = listaMesta;
    }

    public List<Korisnik> getListaKorisnika() {
        return listaKorisnika;
    }

    public void setListaKorisnika(List<Korisnik> listaKorisnika) {
        this.listaKorisnika = listaKorisnika;
    }
    
    
    public void pokreniIzmenuKorisnika(Korisnik k){
        korisnik = k;
        System.out.println("Korisnik je :"+korisnik.getIme());
    }
    

    public String prijaviKorisnika() {

        System.out.println("POZVANA JE METODA - PRIJAVI KORISNIKA");
        System.out.println("Korisnicko ime:" + korisnik.getKorisnickoime() + ", korisnicka sifra:" + korisnik.getKorisnickasifra());
        try {
            korisnik = kontroler.prijaviKorisnika(korisnik);
            return "pocetna.xhtml";
//            System.out.println("SVE JE OK!!!");
        } catch (Exception ex) {
            
            FacesContext context = FacesContext.getCurrentInstance();            
            ResourceBundle bundle = context.getApplication().getResourceBundle(context, "msg");
            context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, bundle.getString("prijava_nespesanlogin"), "Detalji"));
            
            System.out.println("GRESKA:" + ex);

        }
        return null;
    }

    public String sacuvajKorisnika() {

        System.out.println("CUVAM KORISNIKA");
        System.out.println("Mesto u korisniku:"+korisnik.getMesto());
        try {
            
            if (!korisnik.getKorisnickasifra().equals(ponovljenaSifra)){
                
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Korisnicka sifra nije ista kao ponovljena!!!", "Detalji poruke o gresci!!!"));
                return null;
            }
            
            kontroler.sacuvajKorisnika(korisnik);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "USPESNO STE IZMENILI PODATKE", "Detalji poruke!!!"));
            
        } catch (Exception ex) {

            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "GRESKA:"+ex.getMessage(), "Detalji poruke o gresci!!!"));
        }
        return null;

    }
    
    public String pokreniProfilnuStranu(){
        // Ovde mozete inicijalizovati podatke
        
        return "profilnaStrana.xhtml";
    }
    
    
    public static final int ENGLESKI=1;
    public static final int SRPSKI=2;
    
    public String promeniJezik(int jezik){
        
        
        switch(jezik){
            
            case ENGLESKI: 
                FacesContext.getCurrentInstance().getViewRoot().setLocale(Locale.ENGLISH);
                break;
                
            case SRPSKI:
                FacesContext.getCurrentInstance().getViewRoot().setLocale(new Locale("sr","RS"));
                break;
            
        }
        
        
       return null; 
    } 

}
